Loading...
Searching...
No Matches
irr::scene::ITriangleSelector Class Referenceabstract

Interface to return triangles with specific properties. More...

`#include <ITriangleSelector.h>`

Inheritance diagram for irr::scene::ITriangleSelector:

## Public Member Functions

virtual ISceneNode * | getSceneNodeForTriangle (u32 triangleIndex) const =0
| Get scene node associated with a given triangle.
virtual const ITriangleSelector * | getSelector (u32 index) const =0
| Get TriangleSelector based on index based on getSelectorCount.
virtual ITriangleSelector * | getSelector (u32 index)=0
| Get TriangleSelector based on index based on getSelectorCount.
virtual u32 | getSelectorCount () const =0
| Get number of TriangleSelectors that are part of this one.
virtual s32 | getTriangleCount () const =0
| Get amount of all available triangles in this selector.
virtual void | getTriangles (core::triangle3df *triangles, s32 arraySize, s32 &outTriangleCount, const core::aabbox3d< f32 > &box, const core::matrix4 *transform=0) const =0
| Gets the triangles for one associated node which may lie within a specific bounding box.
virtual void | getTriangles (core::triangle3df *triangles, s32 arraySize, s32 &outTriangleCount, const core::line3d< f32 > &line, const core::matrix4 *transform=0) const =0
| Gets the triangles for one associated node which have or may have contact with a 3d line.
virtual void | getTriangles (core::triangle3df *triangles, s32 arraySize, s32 &outTriangleCount, const core::matrix4 *transform=0) const =0
| Gets the triangles for one associated node.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Interface to return triangles with specific properties.

Every ISceneNode may have a triangle selector, available with ISceneNode::getTriangleScelector() or ISceneManager::createTriangleSelector. This is used for doing collision detection: For example if you know, that a collision may have happened in the area between (1,1,1) and (10,10,10), you can get all triangles of the scene node in this area with the ITriangleSelector easily and check every triangle if it collided.

Definition at line 28 of file ITriangleSelector.h.

## Member Function Documentation

## getSceneNodeForTriangle()

virtual ISceneNode * irr::scene::ITriangleSelector::getSceneNodeForTriangle | ( | u32 | triangleIndex | ) | const

pure virtual

Get scene node associated with a given triangle.

This allows to find which scene node (potentially of several) is associated with a specific triangle.

Parameters

  triangleIndex | the index of the triangle for which you want to find the associated scene node.

Returns
  The scene node associated with that triangle.

## getSelector() [1/2]

virtual const ITriangleSelector * irr::scene::ITriangleSelector::getSelector | ( | u32 | index | ) | const

pure virtual

Get TriangleSelector based on index based on getSelectorCount.

Only useful for MetaTriangleSelector, others return 'this' or 0

## getSelector() [2/2]

virtual ITriangleSelector * irr::scene::ITriangleSelector::getSelector | ( | u32 | index | ) |

pure virtual

Get TriangleSelector based on index based on getSelectorCount.

Only useful for MetaTriangleSelector, others return 'this' or 0

## getSelectorCount()

virtual u32 irr::scene::ITriangleSelector::getSelectorCount | ( |  | ) | const

pure virtual

Get number of TriangleSelectors that are part of this one.

Only useful for MetaTriangleSelector, others return 1

## getTriangleCount()

virtual s32 irr::scene::ITriangleSelector::getTriangleCount | ( |  | ) | const

pure virtual

Get amount of all available triangles in this selector.

## getTriangles() [1/3]

virtual void irr::scene::ITriangleSelector::getTriangles | ( | core::triangle3df * | triangles,
|  | s32 | arraySize,
|  | s32 & | outTriangleCount,
|  | const core::aabbox3d< f32 > & | box,
|  | const core::matrix4 * | transform = 0 ) const

pure virtual

Gets the triangles for one associated node which may lie within a specific bounding box.

This returns all triangles for one scene node associated with this selector. If there is more than one scene node associated (e.g. for an IMetaTriangleSelector) this this function may be called multiple times to retrieve all triangles.

This method will return at least the triangles that intersect the box, but may return other triangles as well.

Parameters

  triangles | Array where the resulting triangles will be written to.
  arraySize | Size of the target array.
  outTriangleCount | Amount of triangles which have been written into the array.
  box | Only triangles which are in this axis aligned bounding box will be written into the array.
  transform | Pointer to matrix for transforming the triangles before they are returned. Useful for example to scale all triangles down into an ellipsoid space. If this pointer is null, no transformation will be done.

## getTriangles() [2/3]

virtual void irr::scene::ITriangleSelector::getTriangles | ( | core::triangle3df * | triangles,
|  | s32 | arraySize,
|  | s32 & | outTriangleCount,
|  | const core::line3d< f32 > & | line,
|  | const core::matrix4 * | transform = 0 ) const

pure virtual

Gets the triangles for one associated node which have or may have contact with a 3d line.

This returns all triangles for one scene node associated with this selector. If there is more than one scene node associated (e.g. for an IMetaTriangleSelector) this this function may be called multiple times to retrieve all triangles.

Please note that unoptimized triangle selectors also may return triangles which are not in contact at all with the 3d line.

Parameters

  triangles | Array where the resulting triangles will be written to.
  arraySize | Size of the target array.
  outTriangleCount | Amount of triangles which have been written into the array.
  line | Only triangles which may be in contact with this 3d line will be written into the array.
  transform | Pointer to matrix for transforming the triangles before they are returned. Useful for example to scale all triangles down into an ellipsoid space. If this pointer is null, no transformation will be done.

## getTriangles() [3/3]

virtual void irr::scene::ITriangleSelector::getTriangles | ( | core::triangle3df * | triangles,
|  | s32 | arraySize,
|  | s32 & | outTriangleCount,
|  | const core::matrix4 * | transform = 0 ) const

pure virtual

Gets the triangles for one associated node.

This returns all triangles for one scene node associated with this selector. If there is more than one scene node associated (e.g. for an IMetaTriangleSelector) this this function may be called multiple times to retrieve all triangles.

Parameters

  triangles | Array where the resulting triangles will be written to.
  arraySize | Size of the target array.
  outTriangleCount | Amount of triangles which have been written into the array.
  transform | Pointer to matrix for transforming the triangles before they are returned. Useful for example to scale all triangles down into an ellipsoid space. If this pointer is null, no transformation will be done.

The documentation for this class was generated from the following file:

- ITriangleSelector.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0